#include "ot4xb.ch"
//-------------------------------------------------------------------------------------------------------------------------
#define WM_CONTEXTMENU                  0x007B
#define WM_MOUSEMOVE                    0x0200
#define WM_LBUTTONDOWN                  0x0201
#define WM_LBUTTONUP                    0x0202
#define WM_LBUTTONDBLCLK                0x0203
#define WM_RBUTTONDOWN                  0x0204
#define WM_RBUTTONUP                    0x0205
#define WM_RBUTTONDBLCLK                0x0206
#define WM_MBUTTONDOWN                  0x0207
#define WM_MBUTTONUP                    0x0208
#define WM_MBUTTONDBLCLK                0x0209
//-------------------------------------------------------------------------------------------------------------------------
#define LR_DEFAULTCOLOR     0x00000000
#define LR_MONOCHROME       0x00000001
#define LR_COLOR            0x00000002
#define LR_COPYRETURNORG    0x00000004
#define LR_COPYDELETEORG    0x00000008
#define LR_LOADFROMFILE     0x00000010
#define LR_LOADTRANSPARENT  0x00000020
#define LR_DEFAULTSIZE      0x00000040
#define LR_VGACOLOR         0x00000080
#define LR_LOADMAP3DCOLORS  0x00001000
#define LR_CREATEDIBSECTION 0x00002000
#define LR_COPYFROMRESOURCE 0x00004000
#define LR_SHARED           0x00008000

//-------------------------------------------------------------------------------------------------------------------------
BEGIN STRUCTURE _NOTIFYICONDATA_WIN9X_
   MEMBER DWORD  cbSize
   MEMBER HWND   hWnd
   MEMBER UINT   uID
   MEMBER UINT   uFlags
   MEMBER UINT   uCallbackMessage
   MEMBER HANDLE hIcon
   MEMBER SZSTR  szTip  SIZE 64
END STRUCTURE
//-------------------------------------------------------------------------------------------------------------------------
BEGIN STRUCTURE _NOTIFYICONDATA_WIN2K_
   MEMBER DWORD  cbSize
   MEMBER HWND   hWnd
   MEMBER UINT   uID
   MEMBER UINT   uFlags
   MEMBER UINT   uCallbackMessage
   MEMBER HANDLE hIcon
   MEMBER SZSTR  szTip  SIZE 128
   MEMBER DWORD  dwState
   MEMBER DWORD  dwStateMask
   MEMBER SZSTR  szInfo  SIZE 256
   MEMBER UINT   uTimeout   ; GWSTBACK ; MEMBER UINT uVersion  // inline union
   MEMBER SZSTR  szInfoTitle SIZE 64
   MEMBER DWORD  dwInfoFlags
END STRUCTURE
//-------------------------------------------------------------------------------------------------------------------------
#xtranslate ON NOTIFY <n> EVAL <b> =>       ;
             if nNotify == <n>              ;
            ;    if Valtype(<b> ) == "B"    ;
            ;       Eval( <b> , Self )      ;
            ;    end                        ;
            ;    return NIL                 ;
            ; end
//-------------------------------------------------------------------------------------------------------------------------
CLASS TNotifyIcon
EXPORTED:
   CLASS VAR lWin2K
   VAR hWnd         
   VAR hIcon        
   VAR lSysIcon     
   VAR cTip         
   VAR lInstalled   
   VAR bOnContextMenu
   VAR bOnLDblClick
   VAR bOnLClick
   VAR bOnMouseMove
   VAR aAnimate
   VAR nAnimatePos
   VAR hTimer
       // ---------------------------------------------------------------------------------
INLINE CLASS METHOD initclass()
       ::lWin2K := !(nGetProcAddress("user32","GetGuiResources") == 0 )
       return Self
       // ---------------------------------------------------------------------------------
INLINE METHOD init(uFile,uIcon,cTip)
       local lSysIcon := .F.
       ::hIcon := ::_load_icon_( uFile , uIcon , @lSysIcon)
       ::lSysIcon := lSysIcon
       ::cTip := cTip
       ::lInstalled    := .F.
       ::hWnd := DELEGATED_FPQCALL( {"user32","CreateWindowExA"},;
                                    "__sl__sl__pt__pt__sl__sl__sl__sl__sl__sl__sl__sl__sl",;
                                    0,"_OT4XB_GENERIC_WINDOW_",,,,,,,,,AppInstance(),0;
                                  )
       ot4xb_SubclassWindow( ::hWnd, Self)
       return Self
       // ---------------------------------------------------------------------------------
INLINE CLASS METHOD _load_icon_( uFile , uIcon , lSysIcon)
       local hIcon     := 0
       local cit       := Valtype( uIcon )
       local cif       := Valtype( uFile )        
       local nFlags    := nOr( LR_LOADMAP3DCOLORS , LR_VGACOLOR , LR_DEFAULTSIZE ) 
       
       lSysIcon := .F.
       if (uFile == NIL) .and. (uIcon == NIL)
          return 0
       elseif (uFile == NIL) .and. (cit == "C")
          hIcon := @user32:LoadImageA(AppInstance(),uIcon,1,16,16,nFlags)
       elseif (uFile == NIL) .and. (cit == "N")
          hIcon := @user32:LoadImageA(AppInstance(),MAKEINTRESOURCE(uIcon),1,16,16, nFlags)
       elseif (cif == "C") .and. (cit == "C")
          hIcon := @user32:LoadImageA(nLoadLibrary(uFile),uIcon,1,16,16, nFlags)
       elseif (cif == "C") .and. (cit == "N")
          hIcon := @user32:LoadImageA(nLoadLibrary(uFile),MAKEINTRESOURCE(uIcon),1,16,16, nFlags)
       elseif (cif == "N") .and. (cit == "C")
          hIcon := @user32:LoadImageA(uFile,uIcon,1,16,16, nFlags)
       elseif (cif == "N") .and. (cit == "N")
          if uFile == 0                  
             nFlags := nOr(nFlags,LR_SHARED)
             hIcon := @user32:LoadImageA(uFile,MAKEINTRESOURCE(uIcon),1,16,16,nFlags)
             lSysIcon := !Empty(hIcon)
          else
             hIcon := @user32:LoadImageA(uFile,MAKEINTRESOURCE(uIcon),1,16,16, nFlags)
          end
       elseif (cif == "C") .and. (uIcon == NIL)
          nFlags := nOr(nFlags,LR_LOADFROMFILE)
          hIcon := @user32:LoadImageA(0,uFile,1,16,16,nFlags)
       end
       return hIcon
       // ---------------------------------------------------------------------------------
INLINE METHOD Show()
       local oNi := _NOTIFYICONDATA_WIN9X_():New()
       if (!::lInstalled)  .and. (!Empty(::hIcon))
          WITH OBJECT oNi
             .:cbSize           := .:_sizeof_()
             .:hWnd             := ::hWnd
             .:uID              := 1
             .:uFlags           := iif( ::cTip == NIL , 3 , 7 )
             .:uCallbackMessage := 0x0401 // WM_USER + 1
             .:hIcon            := ::hIcon
             .:szTip            := ::cTip
          END WITH
          ::lInstalled := !( @shell32:Shell_NotifyIconA(0,oNi) == 0 )
          if ::lWin2K ; ::SetWin2KBehavior() ; end
       end
       return ::lInstalled
       // ---------------------------------------------------------------------------------
       
       // ---------------------------------------------------------------------------------
INLINE METHOD SetWin2KBehavior()
       local oNi := _NOTIFYICONDATA_WIN2K_():New()
       if ::lWin2K .and. ::lInstalled
          WITH OBJECT oNi
             .:cbSize           := .:_sizeof_()
             .:hWnd             := ::hWnd
             .:uID              := 1
             .:uFlags           := 0
             .:uVersion         := 3
          END WITH
          return !( @shell32:Shell_NotifyIconA(4,oNi) == 0 )
       end
       return .F.
       // ---------------------------------------------------------------------------------
INLINE METHOD Hide()
       local oNi := _NOTIFYICONDATA_WIN9X_():New()
       if ::lInstalled
          if !Empty(::hTimer) ; @user32:KillTimer(::hWnd , ::hTimer) ; ::hTimer := NIL ; end
          WITH OBJECT oNi
             .:cbSize           := .:_sizeof_()
             .:hWnd             := ::hWnd
             .:uID              := 1
          END WITH
          @shell32:Shell_NotifyIconA(2,oNi)
          ::lInstalled := .F.
       end
       return NIL
       // ---------------------------------------------------------------------------------
INLINE METHOD Destroy()

       ::Hide()
       if !Empty( ::hWnd ) ;  @user32:PostMessageA(::hWnd,0x402,0,0) ; end
       return Self
       // ---------------------------------------------------------------------------------
INLINE METHOD On_WM_DESTROY()
       ::Hide()
       if !Empty( ::hIcon ) .and. (!::lSysIcon) ; @user32:DestroyIcon( ::hIcon ) ; end
       ::lSysIcon := .F. ; ::hIcon := 0
       return NIL
       // ---------------------------------------------------------------------------------
INLINE METHOD Modify(uFile,uIcon,cTip)
       local oNi := _NOTIFYICONDATA_WIN9X_():New()
       local lOldSysIcon := ::lSysIcon
       local hOldIcon    := ::hIcon
       local lNewSysIcon := .F.
       local hNewIcon    := ::_load_icon_( uFile , uIcon , @lNewSysIcon)   
       local nFlags      := 0    
       local lOk         := .T.     
       
       if cTip != NIL
          nFlags := nOr( nFlags , 4 )
          ::cTip := cTip
       end
       if !Empty(hNewIcon) 
          nFlags := nOr( nFlags , 2 )
          ::hIcon    := hNewIcon
          ::lSysIcon := lNewSysIcon
       end
       
       if (::lInstalled)  .and. (!Empty(nFlags))
          WITH OBJECT oNi
             .:cbSize           := .:_sizeof_()
             .:hWnd             := ::hWnd
             .:uID              := 1
             .:uFlags           := nFlags
             .:hIcon            := ::hIcon
             .:szTip            := ::cTip
          END WITH
          lOk := !( @shell32:Shell_NotifyIconA(1,oNi) == 0 )
          if ::lWin2K ; ::SetWin2KBehavior() ; end
       end
       
       if !Empty(hNewIcon)
          if !Empty( hOldIcon ) .and. (!lOldSysIcon) ; @user32:DestroyIcon( hOldIcon ) ; end
       end
       return lOk
       // ---------------------------------------------------------------------------------
INLINE METHOD WndProc( hWnd , nMsg , wp , lp )
       if nMsg == 0x402
          @user32:DestroyWindow(::hWnd)
          return NIL
       elseif nMsg == 0x401 
          return ::OnNotifyIcon( LOWORD(lp) )
       elseif nMsg == 2 // WM_DESTROY
          return ::On_WM_DESTROY()
       elseif nMsg == 0x113 // WM_TIMER
          if !Empty(::aAnimate)
             DEFAULT ::nAnimatePos := 0
             ::nAnimatePos++
             if ::nAnimatePos > Len(::aAnimate) ; ::nAnimatePos := 1 ; end
             ::Modify(::aAnimate[::nAnimatePos][1],::aAnimate[::nAnimatePos][2],::aAnimate[::nAnimatePos][3])
             if (!::lInstalled)  .and. (!Empty(::hIcon))
                ::Show()
             end
          end
          return 0
       end
       return NIL
       // ---------------------------------------------------------------------------------
INLINE METHOD OnNotifyIcon( nNotify )
       ON NOTIFY  WM_MOUSEMOVE      EVAL ::bOnMouseMove
       ON NOTIFY  WM_LBUTTONDOWN    EVAL ::bOnLClick     
       ON NOTIFY  WM_LBUTTONDBLCLK  EVAL ::bOnLDblClick  
       if ::lWin2K
          ON NOTIFY  WM_CONTEXTMENU    EVAL ::bOnContextMenu
       else
          ON NOTIFY  WM_RBUTTONUP      EVAL ::bOnContextMenu
       end
       return NIL
       // ---------------------------------------------------------------------------------
INLINE METHOD ShowInfo(cText,cTitle,nIcon, nTimeOut)
       local oNi := _NOTIFYICONDATA_WIN2K_():New()
       local lOk := .F.
       DEFAULT nIcon    := 0
       DEFAULT cText    := ::cTip
       if ::lWin2K .and. ::lInstalled
          WITH OBJECT oNi
             .:cbSize           := .:_sizeof_()
             .:hWnd             := ::hWnd
             .:uID              := 1
             .:uFlags           := 0x10
             .:szInfo           := cText
             .:uTimeout         := nTimeOut
             .:szInfoTitle      := cTitle
             .:dwInfoFlags      := nIcon
          END WITH
          lOk := !( @shell32:Shell_NotifyIconA(1,oNi) == 0 )
       end
       return lOk
       // ---------------------------------------------------------------------------------
INLINE METHOD HideInfo()
       local oNi := _NOTIFYICONDATA_WIN2K_():New()
       local lOk := .F.
       if ::lWin2K .and. ::lInstalled
          WITH OBJECT oNi
             .:cbSize           := .:_sizeof_()
             .:hWnd             := ::hWnd
             .:uID              := 1
             .:uFlags           := 0x10
             .:szInfo           := ""
             .:uTimeout         := 0
             .:szInfoTitle      := ""
             .:dwInfoFlags      := 0
          END WITH
          lOk := !( @shell32:Shell_NotifyIconA(1,oNi) == 0 )
       end
       return lOk
       // ---------------------------------------------------------------------------------
INLINE METHOD StartAnimation( aIcon , nSpeed )
       local nIcon,nn,nItems,n
       ::StopAnimation()
       DEFAULT nSpeed := 400
       if !Empty(aIcon)        
          nItems := Len( aIcon )
          ::aAnimate := Array( nItems , 3 )
          for n := 1 to nItems
             if Valtype( aIcon[n] ) == "A"
                nn := Len(aIcon[n])
                if nn > 0 ; ::aAnimate[n][1] := aIcon[n][1] ; end
                if nn > 1 ; ::aAnimate[n][2] := aIcon[n][2] ; end
                if nn > 2 ; ::aAnimate[n][3] := aIcon[n][3] ; end
             end
          next
          ::hTimer := @user32:SetTimer(::hWnd,1,nSpeed,0)
          return .T.
       end
       return .F.
       // ---------------------------------------------------------------------------------
INLINE METHOD StopAnimation()
       if !Empty(::hTimer) ; @user32:KillTimer(::hWnd , ::hTimer) ; ::hTimer := NIL ; end
       ::aAnimate    := NIL
       ::nAnimatePos := NIL
       return NIL
       // ---------------------------------------------------------------------------------

ENDCLASS
//-------------------------------------------------------------------------------------------------------------------------
